/**
 * API du serveur de l'application de digitalisation des EP
 * API qui sra utilisée afin de faire communiquer le client et le serveur ainsi que le serveur et la boîte noire.
 *
 * OpenAPI spec version: 1.2.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 *//* tslint:disable:no-unused-variable member-ordering */

import { Inject, Injectable, Optional }                      from '@angular/core';
import { HttpClient, HttpHeaders, HttpParams,
         HttpResponse, HttpEvent }                           from '@angular/common/http';
import { CustomHttpUrlEncodingCodec }                        from '../encoder';

import { Observable }                                        from 'rxjs';

import { EpModel } from '../model/epModel';
import { ErreurModel } from '../model/erreurModel';

import { BASE_PATH, COLLECTION_FORMATS }                     from '../variables';
import { Configuration }                                     from '../configuration';


@Injectable()
export class EpService {

    protected basePath = 'http://localhost:3000/api';
    public defaultHeaders = new HttpHeaders();
    public configuration = new Configuration();

    constructor(protected httpClient: HttpClient, @Optional()@Inject(BASE_PATH) basePath: string, @Optional() configuration: Configuration) {
        if (basePath) {
            this.basePath = basePath;
        }
        if (configuration) {
            this.configuration = configuration;
            this.basePath = basePath || configuration.basePath || this.basePath;
        }
    }

    /**
     * @param consumes string[] mime-types
     * @return true: consumes contains 'multipart/form-data', false: otherwise
     */
    private canConsumeForm(consumes: string[]): boolean {
        const form = 'multipart/form-data';
        for (const consume of consumes) {
            if (form === consume) {
                return true;
            }
        }
        return false;
    }


    /**
     * 
     * lancer la procedure entretien professionnel intermediaire
     * @param idCollaborateur id collaborateur
     * @param idReferent id referent
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public createEPI(idCollaborateur: string, idReferent: string, observe?: 'body', reportProgress?: boolean): Observable<any>;
    public createEPI(idCollaborateur: string, idReferent: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<any>>;
    public createEPI(idCollaborateur: string, idReferent: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<any>>;
    public createEPI(idCollaborateur: string, idReferent: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        if (idCollaborateur === null || idCollaborateur === undefined) {
            throw new Error('Required parameter idCollaborateur was null or undefined when calling createEPI.');
        }

        if (idReferent === null || idReferent === undefined) {
            throw new Error('Required parameter idReferent was null or undefined when calling createEPI.');
        }

        let headers = this.defaultHeaders;

        // authentication (bearerAuth) required
        if (this.configuration.accessToken) {
            const accessToken = typeof this.configuration.accessToken === 'function'
                ? this.configuration.accessToken()
                : this.configuration.accessToken;
            headers = headers.set('Authorization', 'Bearer ' + accessToken);
        }
        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
            'application/json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.request<any>('get',`${this.basePath}/ep/epi`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * recevoir la liste de tous les EP collaborateurs
     * @param idBu id de la business unit à laquelle sont rattachées les données à récupérer
     * @param idAgence id de l&#x27;agence à laquelle sont rattachées les données à récupérer
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public getEP(idBu?: number, idAgence?: number, observe?: 'body', reportProgress?: boolean): Observable<Array<EpModel>>;
    public getEP(idBu?: number, idAgence?: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Array<EpModel>>>;
    public getEP(idBu?: number, idAgence?: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Array<EpModel>>>;
    public getEP(idBu?: number, idAgence?: number, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {



        let queryParameters = new HttpParams({encoder: new CustomHttpUrlEncodingCodec()});
        if (idBu !== undefined && idBu !== null) {
            queryParameters = queryParameters.set('idBu', <any>idBu);
        }
        if (idAgence !== undefined && idAgence !== null) {
            queryParameters = queryParameters.set('idAgence', <any>idAgence);
        }

        let headers = this.defaultHeaders;

        // authentication (bearerAuth) required
        if (this.configuration.accessToken) {
            const accessToken = typeof this.configuration.accessToken === 'function'
                ? this.configuration.accessToken()
                : this.configuration.accessToken;
            headers = headers.set('Authorization', 'Bearer ' + accessToken);
        }
        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
            'application/json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.request<Array<EpModel>>('get',`${this.basePath}/ep`,
            {
                params: queryParameters,
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * recevoir la liste des EP collaborateur
     * @param idCollaborateur id collaborateur
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public getEPByCollaborateur(idCollaborateur: string, observe?: 'body', reportProgress?: boolean): Observable<Array<EpModel>>;
    public getEPByCollaborateur(idCollaborateur: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Array<EpModel>>>;
    public getEPByCollaborateur(idCollaborateur: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Array<EpModel>>>;
    public getEPByCollaborateur(idCollaborateur: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        if (idCollaborateur === null || idCollaborateur === undefined) {
            throw new Error('Required parameter idCollaborateur was null or undefined when calling getEPByCollaborateur.');
        }

        let headers = this.defaultHeaders;

        // authentication (bearerAuth) required
        if (this.configuration.accessToken) {
            const accessToken = typeof this.configuration.accessToken === 'function'
                ? this.configuration.accessToken()
                : this.configuration.accessToken;
            headers = headers.set('Authorization', 'Bearer ' + accessToken);
        }
        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
            'application/json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.request<Array<EpModel>>('get',`${this.basePath}/ep/collaborateur/${encodeURIComponent(String(idCollaborateur))}`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * recevoir un EP par via son id
     * @param idEP id EP
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public getEPById(idEP: string, observe?: 'body', reportProgress?: boolean): Observable<EpModel>;
    public getEPById(idEP: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<EpModel>>;
    public getEPById(idEP: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<EpModel>>;
    public getEPById(idEP: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        if (idEP === null || idEP === undefined) {
            throw new Error('Required parameter idEP was null or undefined when calling getEPById.');
        }

        let headers = this.defaultHeaders;

        // authentication (bearerAuth) required
        if (this.configuration.accessToken) {
            const accessToken = typeof this.configuration.accessToken === 'function'
                ? this.configuration.accessToken()
                : this.configuration.accessToken;
            headers = headers.set('Authorization', 'Bearer ' + accessToken);
        }
        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
            'application/json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.request<EpModel>('get',`${this.basePath}/ep/${encodeURIComponent(String(idEP))}`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * recevoir la liste de tous les EP fait passer par le référent
     * @param idReferent id referent
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public getEPByReferent(idReferent: string, observe?: 'body', reportProgress?: boolean): Observable<Array<EpModel>>;
    public getEPByReferent(idReferent: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Array<EpModel>>>;
    public getEPByReferent(idReferent: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Array<EpModel>>>;
    public getEPByReferent(idReferent: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        if (idReferent === null || idReferent === undefined) {
            throw new Error('Required parameter idReferent was null or undefined when calling getEPByReferent.');
        }

        let headers = this.defaultHeaders;

        // authentication (bearerAuth) required
        if (this.configuration.accessToken) {
            const accessToken = typeof this.configuration.accessToken === 'function'
                ? this.configuration.accessToken()
                : this.configuration.accessToken;
            headers = headers.set('Authorization', 'Bearer ' + accessToken);
        }
        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
            'application/json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.request<Array<EpModel>>('get',`${this.basePath}/ep/referent/${encodeURIComponent(String(idReferent))}`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * recevoir son prochain EP
     * @param idCollaborateur id collaborateur
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public getProchainEPByCollaborateur(idCollaborateur: string, observe?: 'body', reportProgress?: boolean): Observable<EpModel>;
    public getProchainEPByCollaborateur(idCollaborateur: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<EpModel>>;
    public getProchainEPByCollaborateur(idCollaborateur: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<EpModel>>;
    public getProchainEPByCollaborateur(idCollaborateur: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        if (idCollaborateur === null || idCollaborateur === undefined) {
            throw new Error('Required parameter idCollaborateur was null or undefined when calling getProchainEPByCollaborateur.');
        }

        let headers = this.defaultHeaders;

        // authentication (bearerAuth) required
        if (this.configuration.accessToken) {
            const accessToken = typeof this.configuration.accessToken === 'function'
                ? this.configuration.accessToken()
                : this.configuration.accessToken;
            headers = headers.set('Authorization', 'Bearer ' + accessToken);
        }
        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
            'application/json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.request<EpModel>('get',`${this.basePath}/ep/collaborateur/${encodeURIComponent(String(idCollaborateur))}/prochain`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * recevoir la liste de tous les prochaines EP collaborateurs
     * @param idBu id de la business unit à laquelle sont rattachées les données à récupérer
     * @param idAgence id de l&#x27;agence à laquelle sont rattachées les données à récupérer
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public getProchainsEP(idBu?: number, idAgence?: number, observe?: 'body', reportProgress?: boolean): Observable<Array<EpModel>>;
    public getProchainsEP(idBu?: number, idAgence?: number, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Array<EpModel>>>;
    public getProchainsEP(idBu?: number, idAgence?: number, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Array<EpModel>>>;
    public getProchainsEP(idBu?: number, idAgence?: number, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {



        let queryParameters = new HttpParams({encoder: new CustomHttpUrlEncodingCodec()});
        if (idBu !== undefined && idBu !== null) {
            queryParameters = queryParameters.set('idBu', <any>idBu);
        }
        if (idAgence !== undefined && idAgence !== null) {
            queryParameters = queryParameters.set('idAgence', <any>idAgence);
        }

        let headers = this.defaultHeaders;

        // authentication (bearerAuth) required
        if (this.configuration.accessToken) {
            const accessToken = typeof this.configuration.accessToken === 'function'
                ? this.configuration.accessToken()
                : this.configuration.accessToken;
            headers = headers.set('Authorization', 'Bearer ' + accessToken);
        }
        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
            'application/json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.request<Array<EpModel>>('get',`${this.basePath}/ep/prochains`,
            {
                params: queryParameters,
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * recevoir la liste de tous les prochaines EP que fera passer le référent
     * @param idReferent id referent
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public getProchainsEPByReferent(idReferent: string, observe?: 'body', reportProgress?: boolean): Observable<Array<EpModel>>;
    public getProchainsEPByReferent(idReferent: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<Array<EpModel>>>;
    public getProchainsEPByReferent(idReferent: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<Array<EpModel>>>;
    public getProchainsEPByReferent(idReferent: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        if (idReferent === null || idReferent === undefined) {
            throw new Error('Required parameter idReferent was null or undefined when calling getProchainsEPByReferent.');
        }

        let headers = this.defaultHeaders;

        // authentication (bearerAuth) required
        if (this.configuration.accessToken) {
            const accessToken = typeof this.configuration.accessToken === 'function'
                ? this.configuration.accessToken()
                : this.configuration.accessToken;
            headers = headers.set('Authorization', 'Bearer ' + accessToken);
        }
        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
            'application/json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.request<Array<EpModel>>('get',`${this.basePath}/ep/referent/${encodeURIComponent(String(idReferent))}/prochains`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * faire un rappel de signature EP
     * @param idEP id EP
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public rappelSignature(idEP: string, observe?: 'body', reportProgress?: boolean): Observable<any>;
    public rappelSignature(idEP: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<any>>;
    public rappelSignature(idEP: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<any>>;
    public rappelSignature(idEP: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        if (idEP === null || idEP === undefined) {
            throw new Error('Required parameter idEP was null or undefined when calling rappelSignature.');
        }

        let headers = this.defaultHeaders;

        // authentication (bearerAuth) required
        if (this.configuration.accessToken) {
            const accessToken = typeof this.configuration.accessToken === 'function'
                ? this.configuration.accessToken()
                : this.configuration.accessToken;
            headers = headers.set('Authorization', 'Bearer ' + accessToken);
        }
        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
            'application/json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
        ];

        return this.httpClient.request<any>('get',`${this.basePath}/ep/${encodeURIComponent(String(idEP))}/rappelSignature`,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * 
     * update ep
     * @param body 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public updateEP(body: EpModel, observe?: 'body', reportProgress?: boolean): Observable<any>;
    public updateEP(body: EpModel, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<any>>;
    public updateEP(body: EpModel, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<any>>;
    public updateEP(body: EpModel, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {

        if (body === null || body === undefined) {
            throw new Error('Required parameter body was null or undefined when calling updateEP.');
        }

        let headers = this.defaultHeaders;

        // authentication (bearerAuth) required
        if (this.configuration.accessToken) {
            const accessToken = typeof this.configuration.accessToken === 'function'
                ? this.configuration.accessToken()
                : this.configuration.accessToken;
            headers = headers.set('Authorization', 'Bearer ' + accessToken);
        }
        // to determine the Accept header
        let httpHeaderAccepts: string[] = [
            'application/json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected != undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }

        // to determine the Content-Type header
        const consumes: string[] = [
            'application/json'
        ];
        const httpContentTypeSelected: string | undefined = this.configuration.selectHeaderContentType(consumes);
        if (httpContentTypeSelected != undefined) {
            headers = headers.set('Content-Type', httpContentTypeSelected);
        }

        return this.httpClient.request<any>('put',`${this.basePath}/ep/update`,
            {
                body: body,
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

}
